; 
    include \masm32\include\masm32rt.inc
    .586
    include counter2.asm
; 
    .data
        hInst     dd          0
        hWnd      dd          0
        wc        WNDCLASSEX  <>
        msg       MSG         <>
        className db          "test_class",0

        buffer    db 400 dup(0)
    .code
; 
start:
; 
    mov   hInst, rv(GetModuleHandle, NULL)
    mov   wc.cbSize,        sizeof WNDCLASSEX
    mov   wc.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov   wc.lpfnWndProc,   OFFSET WndProc
    mov   wc.cbClsExtra,    NULL
    mov   wc.cbWndExtra,    NULL
    m2m   wc.hInstance,     hInst
    mov   wc.hbrBackground, rv(GetStockObject, WHITE_BRUSH)
    mov   wc.lpszMenuName,  NULL
    mov   wc.lpszClassName, OFFSET className
    mov   wc.hIcon,         rv(LoadIcon, NULL, IDI_APPLICATION)
    mov   wc.hCursor,       rv(LoadCursor, NULL, IDC_ARROW)
    mov   wc.hIconSm,       0
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            chr$("Test"),
                            WS_OVERLAPPEDWINDOW,
                            0,0,300,200,
                            NULL, NULL,
                            hInst, NULL
    mov   hWnd, eax
    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd    
  msgLoop:
    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF (eax != 0)
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
        jmp   msgLoop
    .ENDIF
    exit msg.wParam
; 
WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL ps   :PAINTSTRUCT
    LOCAL hBmp :DWORD
    LOCAL memDC:DWORD
    LOCAL bmi  :BITMAPINFO

    ; Minimal setup so GetDIBits will work (on my system).
    mov bmi.bmiHeader.biSize, sizeof(BITMAPINFO)
    mov bmi.bmiHeader.biPlanes, 1
    mov bmi.bmiHeader.biBitCount, 32
    mov bmi.bmiHeader.biCompression, BI_RGB

    .IF uMsg==WM_PAINT       
      invoke BeginPaint, hWnd, ADDR ps
      mov    hBmp, rv(CreateCompatibleBitmap, ps.hdc, 10, 10)

      invoke GetBitmapBits, hBmp, 400, ADDR buffer
      .IF eax == 0
          MsgBox 0,"GetBitmapBits failed",0,0
          return 0
      .ENDIF

      invoke GetDIBits,ps.hdc,hBmp,9,10,NULL,ADDR bmi,DIB_RGB_COLORS
      .IF eax == 0
          MsgBox 0,"GetDIBits failed",0,0
          return 0
      .ENDIF

      ctr_begin 100, HIGH_PRIORITY_CLASS
        invoke GetDIBits,ps.hdc,hBmp,9,10,NULL,ADDR bmi,DIB_RGB_COLORS
      ctr_end
      push eax

      ctr_begin 100, HIGH_PRIORITY_CLASS
        invoke GetBitmapBits, hBmp, 400, ADDR buffer
      ctr_end

      MsgBox 0,ustr$(eax),"Cycles for GetBitmapBits",0
      pop eax
      MsgBox 0,ustr$(eax),"Cycles for GetDIBits",0

      invoke DeleteObject, hBmp
      invoke DeleteDC, memDC
      invoke EndPaint, hWnd, ADDR ps

    .ELSEIF uMsg == WM_DESTROY
        invoke PostQuitMessage, NULL
        return 0
    .ENDIF
    invoke DefWindowProc, hWin, uMsg, wParam, lParam
    ret
WndProc endp
; 
end start




